/*****************************************************************************\

**   Killer Cracker v8.00 LTD - Un*x Password Cracker - By Doctor Dissector  **

** ========================================================================= **

**      Filename: kc.c  -  Last update: 07/28/91  -  Copyright (c) 1991      **

\*****************************************************************************/



/*

** Killer Cracker - Version 8.00 LTD

** Copyright (C) 1991 By Doctor Dissector

**

** This program is NOT free software BUT may be used without charge or

** payment in any form IF your copy is a "registered" distributed version.

** You may modify it as much as you please, however, you MAY NOT re-

** distribute it, in any shape or for: ie. modified OR unmodified,

** without the expressed written consent (ie. e-mail) of

** Doctor Dissector. (bbs.doctord@doomsday.spies.com)

**

** This program was initially distributed in the hope that it will be

** useful, but WITHOUT ANY WARRANTY; without even the implied warranty of

** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/



/*=[ Copyright ]=============================================================*/



char kc_c_msg[] = "Source: kc.c, Copyright (c)1991 Doctor Dissector";



/*=[ Include KC Header File ]================================================*/



#include "kc.h"



/*=[ General Header Files ]==================================================*/



#include <stdio.h>

#include <string.h>

#include <time.h>

#include <errno.h>



#ifndef _STRIPPED

#include <signal.h>

#endif



#ifdef _MSDOS

#include <sys\types.h>

#endif



#ifdef _UNIX

#include <sys/types.h>

#endif



#ifdef _TURBO

#include <alloc.h>

#endif



#ifdef _MICROSOFT

#include <malloc.h>

#endif



#ifdef _STRIPPED

#include <stdlib.h>

#endif



#ifdef _BSD

#include <sys/time.h>

#include <sys/resource.h>

#endif



/*=[ Include XFDES Encryption Routines ]=====================================*/



#ifdef KC_XFDES

#include "xfdes.c"

#endif



/*=[ Include BCRYPT Encryption Routines ]====================================*/



#ifdef KC_BCRYPT

#include "bcrypt.c"

#endif



/*=[ Structures ]============================================================*/



typedef struct {

    unsigned      uid,              /* User ID of account */

                  gid;              /* Group ID of account */

    char          cracked,          /* Flagged if cracked/inactive */

                  login[14],        /* Account login name */

                  epw[14],          /* 13 character encrypted password */

                  gecos1[15],       /* First word extracted from GECOS */

                  gecos2[15];       /* Second word extracted from GECOS */



#if defined(KC_XFDES)

    unsigned long smask,            /* salt mask of this account */

                  in96[4];          /* 96 bits from "decryption" */

#elif defined(KC_BCRYPT)

    U32           SL[2];            /* salt mask of this account */

    BU64          epwcode;          /* 64 bits from "decryption" */

#endif



} kc_struct;



/*=[ Global Variables ]======================================================*/



kc_struct       *kc;                            /* General data structure */



FILE            *vf,                            /* Valid account file stream */

                *gf;                            /* Word guess file stream */



time_t          timer;                          /* Execution timing variable */



unsigned long   combinations;                   /* Total comparisions */



char            passwordfile[MAX_FILENAME],     /* Passwordfile filename */

                wordfile[MAX_FILENAME],         /* Word guess filename */

                validfile[MAX_FILENAME],        /* Valid account filename */

                restorefile[MAX_FILENAME],      /* Restore file filename */

                progname[MAX_FILENAME],         /* KC's currnet process name */

                errorcode[81],                  /* Exit description */

                lastword[41],                   /* Last word cracked */

                prefixes[81],                   /* guess prefix chars */

                suffixes[81],                   /* guess suffix chars */

                r_word[41],                     /* Restore last word */

                r_account[13];                  /* Restore last account */



int             cracktype,                      /* Word/User based cracking */

                totalusers,                     /* Total number of accounts */

                lastuser,                       /* Index of last user tested */

                r_accnum,                       /* Restore index of account */

                updn,                           /* Upper/lowercase testing? */

                backwards,                      /* Backwards testing? */

                single_chars,                   /* A-Z, a-z, 0-9 testing? */

                funnychar,                      /* ^A-^Z/ESC/SPACE testing? */

                login,                          /* Login name testing? */

                gecos,                          /* GECOS field testing? */

                output,                         /* Output to console? */

                cursuffix,                      /* current suffix */

                curprefix,                      /* current prefix */

                newword,                        /* is this a new word? */

                stoptime,                       /* minutes to die after */

                hog_resources;                  /* Hog resources? */



#ifdef _TURBO

extern unsigned _stklen = 8192;                 /* 8k stack for Turbo C */

#endif



/*===========================================================================*/



/*

**    Function: void initvars(void)

** Description: initialize global variables

*/



void initvars()

{

    cursuffix=0;

    curprefix=0;

    suffixes[0]=0;

    prefixes[0]=0;

    output=1;

    cracktype=WORDS;

    timer=0;

    stoptime=0;

    combinations=0;

    updn=0;

    backwards=0;

    hog_resources=0;

    single_chars=0;

    login=0;

    gecos=0;

    newword=1;

    totalusers=0;

    lastuser=0;

    funnychar=0;

    r_accnum=(-1);

    passwordfile[0]=0;

    wordfile[0]=0;

    validfile[0]=0;

    restorefile[0]=0;

    errorcode[0]=0;

    lastword[0]=0;

    r_account[0]=0;

    r_word[0]=0;

}



/*===========================================================================*/



/*

**    Function: void outstr(char *str)

** Description: output <str> to stdout

**      Return: none

*/



void outstr(str)

    register char *str;

{

    write(1, str, strlen(str));

}



/*===========================================================================*/



/*

**    Function: void showguess(char *str)

** Description: output <str> (current guess) to stdout if output is allowed

**      Return: none

*/



void showguess(str)

    register char *str;

{

    char s[41];



    if (output) {

        sprintf(s, "\n%-8s ", str);

        outstr(s);

    }

}



/*===========================================================================*/



/*

**    Function: void showstr(char *str)

** Description: output <str> to stdout if output is allowed

**      Return: none

*/



void showstr(str)

    register char *str;

{

    if (output)

        outstr(str);

}



/*===========================================================================*/



/*

**    Function: char upchar(char c)

** Description: convert <c> to uppercase

**      Return: uppercase version of <c>, otherwise just <c>

*/



char upchar(c)

    register char c;

{

    return((c>='a') && (c<='z') ? c-32 : c);

}



/*===========================================================================*/



/*

**    Function: char *lowcase(register char *str)

** Description: convert all characters in <str> to lowercase

**      Return: lowercase version of <str>

*/



char *lowcase(str)

    register char *str;

{

    register char *ptr;

    static   char s[41];



    ptr=s;

    while(*str)

        (*ptr++)=(((*str)>='A') && ((*str)<='Z') ? (*str++)+32 : (*str++));

    *ptr=0;

    return(s);

}



/*===========================================================================*/



/*

**    Function: char *upcase(char *str)

** Description: convert all characters in <str> to uppercase

**      Return: uppercase version of <str>

*/



char *upcase(str)

    register char *str;

{

    register char *ptr;

    static   char s[41];



    ptr=s;

    while(*str)

        (*ptr++)=(((*str)>='a') && ((*str)<='z') ? (*str++)-32 : (*str++));

    *ptr=0;

    return(s);

}



/*===========================================================================*/



/*

**    Function: char *reverse(char *str)

** Description: reverse characters in <str>

**      Return: reverse of <str>

*/



char *reverse(str)

    register char *str;

{

    register int  i, j;

    static   char s[41];



    i=strlen(str);

    s[i]=0;

    while(*str)

        s[--i]=(*str++);

    return(s);

}



/*===========================================================================*/



/*

**    Function: void kc_exit(int code)

** Description: exit kc with exit code <code>

**      Return: none

*/



void kc_exit(code)

    int code;

{

    char s[81];



    if (kc)



#if defined(_TURBO)

        farfree(kc);

#elif defined(_MICROSOFT)

        _ffree(kc);

#else

        free(kc);

#endif



#ifdef KC_BCRYPT

    bcrypt_done();

#endif



    if (code) {

        if (code==(-1)) {

            printf("\n\n");

            perror(errorcode);

        }

        printf("\n%s: abnormal program termination\n", progname);

        exit(1);

    }

    else {

        sprintf(s, "\n\n%s, end of session.\n", errorcode);

        showstr(s);

        exit(0);

    }

}



/*===========================================================================*/



/*

**    Function: int openvalid(void)

** Description: open [validfile] for writing

**      Return: 0 upon normal operation, -1 upon error

*/



int openvalid()

{

    vf=fopen(validfile, "a");

    if (!vf) {

        fclose(gf);

        return(-1);

    }

    fprintf(vf, "\n===================================================================");

    fprintf(vf, "\nKC v8.00 LTD -- DO NOT DISTRIBUTE -- By Doctor Dissector -- (C)1991");

    fprintf(vf, "\n-------------------------------------------------------------------");

    fprintf(vf, "\nPasswordfile: %s ", passwordfile);

    fprintf(vf, "\n    Wordfile: %s", wordfile);

    fprintf(vf, "\n-------------------------------------------------------------------");

    return(0);

}



/*===========================================================================*/



/*

**    Function: int openwords(void)

** Description: open [wordfile] for reading

**      Return: 0 upon normal operation, -1 upon error

*/



int openwords()

{

    gf=fopen(wordfile, "r");

    return(!gf ? (-1) : 0);

}



/*===========================================================================*/



/*

**    Function: void closevalid(time_t elapsed, int aborted)

** Description: write session data to [validfile] and close

**      Return: none

*/



void closevalid(elapsed, aborted)

    time_t elapsed;

    int aborted;

{

    double performance;



    if (elapsed<1)

        elapsed=1;

    fprintf(vf,"\n-------------------------------------------------------------------");

    if (aborted) {

        if (login)

            strcpy(lastword, "Logins");

        else if (gecos)

            strcpy(lastword, "Gecos");

        else if (cracktype==WORDS) {

            if (single_chars)

                strcpy(lastword, "a-z, A-Z, 0-9");

            else if (funnychar)

                strcpy(lastword, "^A-^Z, ESC, SPACE");

         }

        if ((login) || (gecos) || (cracktype==WORDS))

            fprintf(vf, "\n*** Cracking aborted, word: %s", lastword);

        else

            fprintf(vf, "\n*** Cracking aborted, account: %s", kc[lastuser].login);

        fprintf(vf, "\n-------------------------------------------------------------------");

    }

    performance=(double)combinations/elapsed;

    fprintf(vf, "\nSession Total: Encryption/Comparisions: %lu", combinations);

    fprintf(vf, "\nSession Total: Time Elapsed In Seconds: %lu", elapsed);

    fprintf(vf, "\nSession Efficiency: Encryptions/Second: %.2f", performance);

    fprintf(vf, "\n===================================================================");

    fclose(vf);

}



/*===========================================================================*/



/*

**    Function: void closeall(time_t elapsed)

** Description: initiate closing of [validfile] and [wordfile]

**      Return: none

*/



void closeall(elapsed)

    time_t elapsed;

{

    closevalid(elapsed, 0);

    fclose(gf);

}



/*===========================================================================*/



/*

**    Function: void foundvalid(int un, char *dpw)

** Description: record valid account information

**      Return: none

*/



void foundvalid(un, dpw)

    int un;

    char *dpw;

{

    static char s[81];



    fprintf(vf, "\nAccount: %-12s  Password: %-10s  UID: %-5d  GID: %d",

        kc[un].login, dpw, kc[un].uid, kc[un].gid);

    fflush(vf);

    sprintf(s, "\n>>>>>>>>>> Account: %-12s  Password: %-10s  UID: %-5d  GID: %d\n",

        kc[un].login, dpw, kc[un].uid, kc[un].gid);

    showstr(s);

}



/*===========================================================================*/



#ifdef DEBUGGING

/*

**    Function: void foundinactive(int un)

** Description: show inactive account information

**      Return: none

*/



void foundinactive(un)

    int un;

{

    static char s[81];



    sprintf(s, "\n>>>>>>>>>> Inactive account: %-12s  UID: %-5d  GID: %d\n",

        kc[un].login, kc[un].uid, kc[un].gid);

    showstr(s);

}

#endif



/*===========================================================================*/



/*

**    Function: char *getfield(char *fields, int gecosfield)

** Description: retrieve next field from <fields> of type <gecosfield>

**      Return: next field from <fields> of type <gecosfield>

*/



char *getfield(fields, gecosfield)

    char *fields;

    int gecosfield;

{

    register int  i;

             char curfield[50], newfields[200];



    if (gecosfield) {

        for(i=0; (i<200) && (!strchr(":, ", fields[i])); i++)

            curfield[i]=fields[i];

    }

    else {

        for(i=0; (i<200) && (fields[i]!=':'); i++)

            curfield[i]=fields[i];

    }

    curfield[i]=0;

    strcpy(newfields, &fields[i+1]);

    if (fields[i]==':')

        fields[0]=0;

    strcpy(fields, newfields);

    return(curfield);

}



/*===========================================================================*/



/*

**    Function: int getpw(void)

** Description: reads [passwordfile] and loads data into [kc] data structures

**      Return: <u> (number of accounts) upon normal operation, -1 if an error

**              occurs opening [passwordfile] for reading, -2 if an error

**              occurs during allocation of memory for [kc]

*/



int getpw()

{

    register int  i, u;

             char s[200], sw[200];

             FILE *f;



    f=fopen(passwordfile, "r");

    if (!f)

        return(-1);

    for(u=0; (fgets(s, 199, f)); u++)

        ;

    fclose(f);



#if defined(_TURBO)

    kc=(kc_struct *)farmalloc(u*sizeof(kc_struct));

#elif defined(_MICROSOFT)

    kc=(kc_struct *)_fmalloc(u*sizeof(kc_struct));

#else

    kc=(kc_struct *)malloc(u*sizeof(kc_struct));

#endif



    if (!kc)

        return(-2);

    f=fopen(passwordfile, "r");

    if (!f)

        return(-1);

    for(i=0; i<u; i++) {

        fgets(s, 199, f);

        strcpy(sw, getfield(s, 0));

        sw[12]=0;

        strcpy(kc[i].login, sw);

        if ((cracktype==USERS) && (r_accnum==(-1))) {

            if (!strcmp(kc[i].login, r_account))

                r_accnum=i;

        }

        strcpy(sw, getfield(s, 0));

        sw[13]=0;

        strcpy(kc[i].epw, sw);

        strcpy(sw, getfield(s, 0));

        kc[i].uid=atoi(sw);

        strcpy(sw, getfield(s, 0));

        kc[i].gid=atoi(sw);

        do {

            strcpy(sw, getfield(s, 1));

        } while((sw[0]) && (sw[1]=='.'));

        if (sw[0]) {

            sw[14]=0;

            strcpy(kc[i].gecos1, sw);

            strcpy(s, sw);

            do {

                strcpy(sw, getfield(s, 1));

            } while((sw[0]) && (sw[1]=='.'));

            if (sw[0]) {

                sw[14]=0;

                strcpy(kc[i].gecos2, sw);

            }

            else

                kc[i].gecos2[0]=0;

        }

        else {

            kc[i].gecos1[0]=0;

            kc[i].gecos2[0]=0;

        }

        if (!kc[i].epw[0]) {

            foundvalid(i, "(blank)");

            kc[i].cracked=1;

        }

        else if (strlen(kc[i].epw)<13) {



#ifdef DEBUGGING

            foundinactive(i);

#endif



            kc[i].cracked=1;

        }

        else {



#if defined(KC_XFDES)

            kc[i].smask=

                tfTOsixbit((sbpb24)(SALT1[kc[i].epw[0]]|SALT2[kc[i].epw[1]]));

            kc_decrypt(kc[i].in96, kc[i].epw);

#elif defined(KC_BCRYPT)

            bcrypt_salt_to_E(kc[i].epw[0], kc[i].epw[1], kc[i].SL);

            kc[i].epwcode=bcrypt_pw_to_BU64(kc[i].epw+2);

#endif



            kc[i].cracked=0;

        }

    }

    fclose(f);

    return(u);

}



/*===========================================================================*/



/*

**    Function: int findtype(int curtype)

** Description: determines the current word combination for current guess

**      Return: combination type of guess, DONE if no more combinations

*/



int findtype(curtype)

    register int curtype;

{

    register int newtype;



    if ((updn) && (backwards))

        newtype=((curtype>=LOWBW) ? DONE : curtype+1);

    else if (updn)

        newtype=((curtype>=LOWCASE) ? DONE : curtype+1);

    else if (backwards)

        newtype=((curtype>=BW) ? DONE : BW);

    else newtype=DONE;

    if (newtype==DONE)

        if ((curprefix>(-1)) && (prefixes[curprefix]))

            newtype=PREFIXES;

        else if ((cursuffix>(-1)) && (suffixes[cursuffix]))

            newtype=SUFFIXES;

    return(newtype);

}



/*===========================================================================*/



/*

**    Function: char *makeword(char *str, int wordtype)

** Description: creates the correct combination of the current guess

**      Return: combination of the current guess, <s[0]=0> if combination

**              would be repetitive

*/



char *makeword(str, wordtype)

    register char *str;

    register int wordtype;

{

    register int j;

    static   char s[21];



    switch(wordtype) {

        case NORMAL:

            strcpy(s, str);

            break;

        case UPCASE:

            strcpy(s, upcase(str));

            if (!strcmp(s, str))

                s[0]=0;

            break;

        case LOWCASE:

            strcpy(s, lowcase(str));

            if (!strcmp(s, str))

                s[0]=0;

            break;

        case BW:

            strcpy(s, reverse(str));

            if (!strcmp(s, str))

                s[0]=0;

            break;

        case UPBW:

            strcpy(s, upcase(reverse(str)));

            if (!((strcmp(s, upcase(str))) && (strcmp(s, reverse(str)))))

                s[0]=0;

            break;

        case LOWBW:

            strcpy(s, lowcase(reverse(str)));

            if (!((strcmp(s, lowcase(str))) && (strcmp(s, reverse(str)))))

                s[0]=0;

            break;

        case PREFIXES:

            sprintf(s, "%c%s", prefixes[curprefix], str);

            curprefix++;

            break;

        case SUFFIXES:

            if (strlen(str)<8)

                sprintf(s, "%s%c", str, suffixes[cursuffix]);

            else

                s[0]=0;

            cursuffix++;

            break;

    }

    s[8]=0;

    newword=1;

    return(s);

}



/*===========================================================================*/



/*

**    Function: char *nextword(void)

** Description: retrieves next word from [wordfile]

**      Return: next word in [wordfile], <lastword[0]=0> if no more words

*/



char *nextword()

{

    if (!fgets(lastword, 30, gf))

        lastword[0]=0;

    else {

        lastword[strlen(lastword)-1]=0;

        lastword[12]=0;

    }

    return(lastword);

}



/*===========================================================================*/



/*

**    Function: int testpw(int un, char *dpw)

** Description: actually compares <dpw> (decrypted password, current guess)

**              to the current account's encrypted password

**      Return: 1 if both encrypted passwords match, 0 if not

*/



int testpw(un, dpw)

    int un;

    char *dpw;

{



#ifdef KC_BCRYPT

    BU64 resultcode;

#endif



    lastuser=un;

    combinations++;



#ifdef DEBUGGING

    char s[41];

    sprintf(s, "/%s", dpw);

    showstr(s);

#endif



#if defined(KC_XFDES)

    /* kc_fcrypt() returns 1 if a match occurs, 0 if no match occurs */

    if (kc_fcrypt(dpw, kc[un].smask, kc[un].in96, newword)) {

#elif defined(KC_BCRYPT)

    resultcode=kc_bcrypt(dpw, kc[un].SL[0], kc[un].SL[1], newword);

    if ((kc[un].epwcode.L.U==resultcode.L.U) &&

        (kc[un].epwcode.R.U==resultcode.R.U)) {

#else

    if (!strcmp(kc[un].epw, crypt(dpw, kc[un].epw))) {

#endif



        kc[un].cracked++;

        foundvalid(un, dpw);

    }

    showstr("-");

    newword=0;

    return(kc[un].cracked);

}



/*===========================================================================*/



/*

**    Function: void login_testpw(int un, int wordtype)

** Description: does login account name testing

**      Return: none

*/



void login_testpw(un, wordtype)

    int un, wordtype;

{

    static char s[11];



    if (!kc[un].cracked) {

        strcpy(s, makeword(kc[un].login, wordtype));

        if (s[0])

            testpw(un, s);

        else

            showstr("*");

    }

    else

        showstr("+");

}



/*===========================================================================*/



/*

**    Function: void gecos_testpw(int un, int wordtype, int field)

** Description: does gecos field testing

**      Return: none

*/



void gecos_testpw(un, wordtype, field)

    int un, wordtype, field;

{

    static char s[11];



    if (!kc[un].cracked) {

        if (field==1)

            strcpy(s, makeword(kc[un].gecos1, wordtype));

        else

            strcpy(s, makeword(kc[un].gecos2, wordtype));

        if (s[0])

            testpw(un, s);

        else

            showstr("*");

    }

    else

        showstr("+");

}



/*===========================================================================*/



/*

**    Function: void testfirst(int firsttype)

** Description: initiates login/gecos testing

**      Return: none

*/



void testfirst(firsttype)

    int firsttype;

{

    register int  curuser, alldone=0, wordtype=NORMAL;

    static   char s[11], t[11];



    switch(firsttype) {

        case LOGIN:

            strcpy(s, "Logins");

            break;

        case GECOS1:

            strcpy(s, "1Gecos");

            break;

        case GECOS2:

            strcpy(s, "2Gecos");

            break;

    }

    curprefix=0;

    cursuffix=0;

    while (!alldone) {

        strcpy(t, makeword(s, wordtype));

        showguess(t);

        for(curuser=0; curuser<totalusers; curuser++) {

            newword=1;

            switch(firsttype) {

                case LOGIN:

                    login_testpw(curuser, wordtype);

                    break;

                case GECOS1:

                    gecos_testpw(curuser, wordtype, 1);

                    break;

                case GECOS2:

                    gecos_testpw(curuser, wordtype, 2);

                    break;

            }

        }

        wordtype=findtype(wordtype);

        if (wordtype==DONE)

            alldone=1;

    }

}



/*===========================================================================*/



/*

**    Function: void testpw_char(char ichar, char funny)

** Description: tests single characters

**      Return: none

*/



void testpw_char(ichar, funny)

    register char ichar, funny;

{

    register int curuser;

    static   char w[2], s[11];



    if (funny) {

        if (ichar<27) {

            sprintf(s, "^%c", (ichar-1)+'A');

            showguess(s);

        }

        else if (ichar==27)

            showguess("<ESC>");

        else

            showguess("<SPACE>");

    }

    else

        showguess(w);

    sprintf(w, "%c", ichar);

    newword=1;

    for(curuser=0; curuser<totalusers; curuser++) {

        if (!kc[curuser].cracked)

            testpw(curuser, w);

        else

            showstr("+");

    }

}



/*===========================================================================*/



/*

**    Function: void test_chars(void)

** Description: initiates a-z, A-Z, 0-9 character testing

**      Return: none

*/



void test_chars()

{

    register char c;



    for(c='a'; c<'{'; c++)

        testpw_char(c, 0);

    for(c='A'; c<'['; c++)

        testpw_char(c, 0);

    for(c='0'; c<':'; c++)

        testpw_char(c, 0);

}



/*===========================================================================*/



/*

**    Function: void testfunny(void)

** Description: initiates ^A-^Z, ESC, SPACE testing

**      Return: none

*/



void testfunny()

{

    register char c;



    for(c=1; c<28; c++)

        testpw_char(c, 1);

    testpw_char(32, 1);

}



/*===========================================================================*/



/*

**    Function: void kc_words(void)

** Description: initiates cracking session by words

**      Return: none

*/



void kc_words()

{

    register int  wordtype=NORMAL, curuser;

    static   char w[13], t[13];



    if (single_chars)

        test_chars();

    single_chars=0;

    if (funnychar)

        testfunny();

    funnychar=0;

    if (r_word[0]) {

        do {

            strcpy(w, nextword());

        } while((w[0]) && (strcmp(w, r_word)));

    }

    else

        strcpy(w, nextword());

    while(w[0]) {

        curprefix=0;

        cursuffix=0;

        while (wordtype!=DONE) {

            strcpy(t, makeword(w, wordtype));

            if (t[0]) {

                showguess(t);

                for(curuser=0; curuser<totalusers; curuser++) {

                    if (kc[curuser].cracked)

                        showstr("+");

                    else

                        testpw(curuser, t);

                }

            }

            wordtype=findtype(wordtype);

        }

        strcpy(w, nextword());

        wordtype=NORMAL;

    }

}



/*===========================================================================*/



/*

**    Function: void kc_users(void)

** Description: initiates cracking session by users

**      Return: none

*/



void kc_users()

{

    register int  c, i, curuser, wordtype=NORMAL;

    static   char w[13], t[13];



    i=(r_accnum==(-1) ? 0 : r_accnum);

    for(curuser=i; curuser<totalusers; curuser++) {

        if (!kc[curuser].cracked) {

            showguess(kc[curuser].login);

            if (single_chars) {

                for(c='a'; (c<'{') && (!kc[curuser].cracked); c++) {

                    newword=1;

                    sprintf(t, "%c", c);

                    testpw(curuser, t);

                }

                for(c='A'; (c<'[') && (!kc[curuser].cracked); c++) {

                    newword=1;

                    sprintf(t, "%c", c);

                    testpw(curuser, t);

                }

                for(c='0'; (c<':') && (!kc[curuser].cracked); c++) {

                    newword=1;

                    sprintf(t, "%c", c);

                    testpw(curuser, t);

                }

            }

            if (funnychar) {

                for(c=1; (c<28) && (!kc[curuser].cracked); c++) {

                    newword=1;

                    sprintf(t, "%c", c);

                    testpw(curuser, t);

                }

                newword=1;

                sprintf(t, "%c", 32);

                testpw(curuser, t);

            }

            strcpy(w, nextword());

            while((w[0]) && (!kc[curuser].cracked)) {

                curprefix=0;

                cursuffix=0;

                while((wordtype!=DONE) && (!kc[curuser].cracked)) {

                    strcpy(t, makeword(w, wordtype));

                    if (t[0])

                        testpw(curuser, t);

                    else

                        showstr("*");

                    wordtype=findtype(wordtype);

                }

                strcpy(w, nextword());

                wordtype=NORMAL;

            }

            fclose(gf);

            gf=fopen(wordfile, "r");

        }

    }

}



/*===========================================================================*/



/*

**    Function: void getstat(void)

** Description: prompts for files unspecified by the command line

**      Return: none

*/



void getstat()

{

    printf("\n");

    if (!passwordfile[0]) {

        printf("Passwordfile: ");

        gets(passwordfile);

    }

    if (!wordfile[0]) {

        printf("Wordfile    : ");

        gets(wordfile);

    }

    if (!validfile[0]) {

        printf("Validfile   : ");

        gets(validfile);

    }

}



/*===========================================================================*/



/*

**    Function: void printfiles(void)

** Description: prints current filenames specified

**      Return: none

*/



void printfiles()

{

    printf("\nPasswordfile : %s", passwordfile);

    printf("\nWordfile     : %s", wordfile);

    printf("\nValidfile    : %s\n", validfile);

}



/*===========================================================================*/



/*

**    Function: void printstat(void)

** Description: prints current options specified

**      Return: none

*/



void printstat()

{

    char s[81];



    switch(cracktype) {

        case WORDS:

            printf("\n* Testing based on words");

            break;

        case USERS:

            printf("\n* Testing based on users");

            break;

    }

    printf("\n* Normal output to console");

    if (login)

        printf("\n* Test login names as passwords");

    if (gecos)

        printf("\n* Test GECOS field names as passwords");

    if (single_chars)

        printf("\n* a-z, A-Z, 0-9 single character testing");

    if (funnychar)

        printf("\n* ^A-^Z, ESC, SPACE funny character testing");

    if (updn)

        printf("\n* Uppercase & lowercase testing");

    if (backwards)

        printf("\n* Backwards word testing");

    if (prefixes[0])

        printf("\n* Character prefixes: %s", prefixes);

    if (suffixes[0])

        printf("\n* Character suffixes: %s", suffixes);

    if (hog_resources)

        printf("\n* Attempt to hog system resources");

    if (stoptime>0)

        printf("\n* Session timeout: %d minutes", stoptime);

    printf("\n\nInitializing session data, please wait...\n");

    fflush(stdout);

}



/*===========================================================================*/



/*

**    Function: char *getoptions(void)

** Description: creates a string including session flags

**      Return: string containing session flags

*/



char *getoptions()

{

    char flags[81];

    int  i=0;



    if (backwards)

        flags[i++]='b';

    if (updn)

        flags[i++]='c';

    if (!output)

        flags[i++]='o';



#ifdef _BSD

    if (hog_resources)

        flags[i++]='h';

#endif



    if (cracktype==USERS)

        flags[i++]='u';

    flags[i]=0;

    return(flags);

}



/*===========================================================================*/



/*

**    Function: void saveoptions(int done)

** Description: saves current session information into [restorefile]

**      Return: none

*/



void saveoptions(done)

    int done;

{

    FILE *rf;



    if (!restorefile[0])

        rf=fopen("restore", "w");

    else

        rf=fopen(restorefile, "w");

    if (!rf) {

        strcpy(errorcode, (!restorefile[0] ? "restore" : restorefile));

        kc_exit(-1);

    }

    fprintf(rf, "Passwordfile=%s\n", passwordfile);

    fprintf(rf, "Wordfile=%s\n", wordfile);

    fprintf(rf, "Validfile=%s\n", validfile);

    fprintf(rf, "Flags=%s\n", getoptions());

    fprintf(rf, "Prefixes=%s\n", prefixes);

    fprintf(rf, "Suffixes=%s\n", suffixes);



#if defined(_SYSV) || defined(_BSD)

    fprintf(rf, "Timeout=%d\n", (stoptime>0 ? stoptime : 0));

#endif



    if (cracktype==USERS)

        if (!done)

            fprintf(rf, "Lastaccount=%s\n", kc[lastuser].login);

        else

            fprintf(rf, "Lastaccount=*****DONE*****\n");

    else {

        if (!done) {

            if ((login) || (gecos) || (single_chars) || (funnychar))

                strcpy(lastword, nextword());

            fprintf(rf, "Lastword=%s", lastword);

        }

        else

            fprintf(rf, "Lastword=*****DONE*****");

    }

    fclose(rf);

}



/*===========================================================================*/



/*

**    Function: char *getnexttoken(char *s, char c)

** Description: retrieve next token from <s> separated by <c>

**      Return: next token in <s>

*/



char *getnexttoken(s, c)

    char *s, c;

{

    register int i, j;

    char token[256];



    for(i=0; s[i]!=c; i++)

        ;

    i++;

    for(j=0; (s[i]) && (s[i]!='\r') && (s[i]!='\n'); i++, j++)

        token[j]=s[i];

    token[j]=0;

    return(token);

}



/*===========================================================================*/



/*

**    Function: char *getfirsttoken(char *s, char c)

** Description: retrieve first token from <s> separated by <c>

**      Return: first token in <s>

*/



char *getfirsttoken(s, c)

    char *s, c;

{

    register int i;

    char token[MAX_FILENAME];



    for(i=0; ((token[i]=s[i])!=c); i++)

        ;

    token[i]=0;

    return(token);

}



/*===========================================================================*/



/*

**    Function: void printtitle(void)

** Description: prints kc version and copyright

**      Return: none

*/



void printtitle()

{

    printf("\nKiller Cracker v8.00 LTD (7/28/91)");

    printf("\nCopyright (C) 1991, By Doctor Dissector");

    printf("\n\n*DO NOT DISTRIBUTE* this version without the written");

    printf("\nconsent of Doctor Dissector, bbs.doctord@doomsday.spies.com\n");

}



/*===========================================================================*/



/*

**    Function: void readoptions(char *options)

** Description: reads and initializes command line flags/restorefile flags

**      Return: none

*/



void readoptions(options)

    char *options;

{

    if (strchr(options, '1'))

        single_chars=1;

    if (strchr(options, 'B'))

        backwards=1;

    if (strchr(options, 'C'))

        updn=1;

    if (strchr(options, 'F'))

        funnychar=1;

    if (strchr(options, 'G'))

        gecos=1;

    if (strchr(options, 'H'))

        hog_resources=1;

    if (strchr(options, 'L'))

        login=1;

    if (strchr(options, 'O'))

        output=0;

    if (strchr(options, 'U'))

        cracktype=USERS;

}



/*===========================================================================*/



/*

**    Function: int restore(void)

** Description: restores session saved in [restorefile]

**      Return: 0 upon normal operation, -1 if an error occurs opening

**              [restorefile] for reading, 1 if the identifier field

**              is invalid

*/



int restore()

{

    FILE *rf;

    char s[256];



    rf=fopen(restorefile, "r");

    if (!rf) {

        strcpy(errorcode, restorefile);

        kc_exit(-1);

    }

    while(fgets(s, 255, rf)) {

        if (!strcmp(upcase(getfirsttoken(s, '=')), "PASSWORDFILE"))

            strcpy(passwordfile, getnexttoken(s, '='));

        else if (!strcmp(upcase(getfirsttoken(s, '=')), "WORDFILE"))

            strcpy(wordfile, getnexttoken(s, '='));

        else if (!strcmp(upcase(getfirsttoken(s, '=')), "VALIDFILE"))

            strcpy(validfile, getnexttoken(s, '='));

        else if (!strcmp(upcase(getfirsttoken(s, '=')), "FLAGS"))

            readoptions(upcase(getnexttoken(s, '=')));

        else if (!strcmp(upcase(getfirsttoken(s, '=')), "PREFIXES"))

            strcpy(prefixes, getnexttoken(s, '='));

        else if (!strcmp(upcase(getfirsttoken(s, '=')), "SUFFIXES"))

            strcpy(suffixes, getnexttoken(s, '='));

        else if (!strcmp(upcase(getfirsttoken(s, '=')), "TIMEOUT"))

            stoptime=atoi(getnexttoken(s, '='));

        else if (!strcmp(upcase(getfirsttoken(s, '=')), "LASTACCOUNT"))

            strcpy(r_account, getnexttoken(s, '='));

        else if (!strcmp(upcase(getfirsttoken(s, '=')), "LASTWORD"))

            strcpy(r_word, getnexttoken(s, '='));

        else

            return(1);

    }

    fclose(rf);

    if (output)

        printtitle();

    if ((!passwordfile[0]) || (!wordfile[0]) || (!validfile[0]))

        return(1);

    if (((cracktype==WORDS) && (!r_word[0])) ||

        ((cracktype==USERS) && (!r_account[0])))

        return(1);

    if (output) {

        if ((!strcmp(r_word, "*****DONE*****")) ||

            (!strcmp(r_account, "*****DONE*****"))) {

            printf("\n*** Session previously completed\n\n");

            exit(0);

        }

        if ((cracktype==WORDS) && (r_word[0]))

            printf("\n*** Restoring, Word: %s\n", r_word);

        else if ((cracktype==USERS) && (r_account[0]))

            printf("\n*** Restoring, Account: %s\n", r_account);

        printfiles();

        printstat();

    }

    return(0);

}



/*===========================================================================*/



/*

**    Function: void/int handler(void)

** Description: interrupt handler for aborting crack sessions

**      Return: none/0

*/



#ifndef _STRIPPED

#if defined(_BSD) || defined(_SYSV)

int handler()

#else

void handler()

#endif



{

    time_t temp;



#if defined(_SYSV) || defined(_BSD)

    signal(SIGQUIT, SIG_IGN);

    signal(SIGINT, SIG_IGN);

    signal(SIGALRM, SIG_IGN);

#else

    signal(SIGINT, SIG_IGN);

#endif



    closevalid(time(&temp)-timer, 1);

    saveoptions(0);

    fclose(gf);

    strcpy(errorcode, "Cracking aborted");

    kc_exit(0);



#if defined(_BSD) || defined(_SYSV)

    return(0);

#endif



}



/*===========================================================================*/



/*

**    Function: void setsignals(void)

** Description: initializes interrupts and interrupt handler

**      Return: none

*/



void setsignals()

{



#if defined(_TURBO) || defined(_MICROSOFT)

    signal(SIGINT, handler);

#else

    signal(SIGINT, handler);

    signal(SIGQUIT, handler);

    signal(SIGALRM, handler);

    signal(SIGHUP, SIG_IGN);

#endif



}

#endif



/*===========================================================================*/



/*

**    Function: void maxcpulimit(void)

** Description: maximizes cpu limit if limit is not currently set to max

**      Return: none

*/



#ifdef _BSD

void maxcpulimit()

{

    struct rlimit r;



    getrlimit(RLIMIT_CPU, &r);

    r.rlim_cur=r.rlim_max;

    setrlimit(RLIMIT_CPU, &r);

}

#endif



/*===========================================================================*/



/*

**    Function: void crack(void)

** Description: backgrounds process, initiates all cracking

**      Return: none

*/



void crack()

{

    char   s[81];

    time_t temp;



#if defined(_SYSV) || defined(_BSD)

    if (!output) {

        if (isatty(0)) {

            close(0);

            close(1);

            close(2);

            if (fork())

                exit(0);

        }

        else {

            close(0);

            close(1);

            close(2);

        }

    }

    if (stoptime>0)

        alarm((stoptime*60));

#endif



    sprintf(s,"\nCracking %d accounts...\n", totalusers);

    showstr(s);

    timer=time(&temp);

    if (login)

        testfirst(LOGIN);

    login=0;

    if (gecos) {

        testfirst(GECOS1);

        testfirst(GECOS2);

    }

    gecos=0;

    switch(cracktype) {

        case WORDS:

            kc_words();

            break;

        case USERS:

            kc_users();

            break;

    }

    closeall(time(&temp)-timer);

    if (restorefile[0])

        saveoptions(1);

    strcpy(errorcode, "Cracking complete");

}



/*===========================================================================*/



/*

**    Function: int initall(void)

** Description: initiates setup procedures for crack session

**      Return: 0 if no errors occur, -1 if an error occurs

*/



int initall()

{



#ifndef _STRIPPED

    setsignals();

#endif



    if (openwords()==(-1)) {

        strcpy(errorcode, wordfile);

        return(-1);

    }

    if (openvalid()==(-1)) {

        strcpy(errorcode, validfile);

        fclose(gf);

        return(-1);

    }

    totalusers=getpw();

    if (totalusers<0) {

        if (totalusers==(-1))

            strcpy(errorcode, passwordfile);

        else if (totalusers==-2)

            strcpy(errorcode, "malloc failed");

        else kc_exit(1);

        return(-1);

    }

    if ((cracktype==USERS) && (r_accnum==(-1)) && (restorefile[0])) {

        fclose(gf);

        printf("\n%s: invalid account name: %s\n", progname, r_account);

        kc_exit(1);

    }



#ifdef _BSD

    if (hog_resources)

        maxcpulimit();

#endif



#if defined(KC_XFDES)

    init_des();

#elif defined(KC_BCRYPT)

    bcrypt_init();

#endif



    return(0);

}



/*===========================================================================*/



/*

**    Function: void printusage(void)

** Description: prints usage information

**      Return: none

*/



#define ENCRYPTED_TEST_PASSWORD  "MX4WdnjbWMTKQ"

#define PLAINTEXT_TEST_PASSWORD  "robert"



void test_crypt()

{



#ifdef KC_XFDES

    sbpb24 in96[4], smask;

#endif



    char   epw[21];



#ifdef KC_BCRYPT

    U32    SL[2];

    BU64   epwcode, resultcode;

#endif



    printtitle();

    printf("\nTesting encrypted password '%s' as '%s'...",

        ENCRYPTED_TEST_PASSWORD, PLAINTEXT_TEST_PASSWORD);

    strcpy(epw, ENCRYPTED_TEST_PASSWORD);



#if defined(KC_XFDES)

    init_des();

    smask=tfTOsixbit((sbpb24)(SALT1[epw[0]]|SALT2[epw[1]]));

    kc_decrypt(in96, epw);

    if (kc_fcrypt(PLAINTEXT_TEST_PASSWORD, smask, in96, 1)) {

#elif defined(KC_BCRYPT)

    bcrypt_init();

    bcrypt_salt_to_E(epw[0], epw[1], SL);

    epwcode=bcrypt_pw_to_BU64(epw+2);

    resultcode=kc_bcrypt(PLAINTEXT_TEST_PASSWORD, SL[0], SL[1], 1);

    bcrypt_done();

    if ((epwcode.L.U==resultcode.L.U) && (epwcode.R.U==resultcode.R.U)) {

#else

    if (!strcmp(epw, crypt(PLAINTEXT_TEST_PASSWORD, epw))) {

#endif



        printf("\n\nTest complete.  No errors detected.\n");

        exit(0);

    }

    else {

        printf("\n\nEncryption/compare error!  The encrypted plaintext password");

        printf("\ndid not match the encrypted password!\n");

        exit(1);

    }

}



/*===========================================================================*/



/*

**    Function: void printusage(void)

** Description: prints usage information

**      Return: none

*/



void printusage()

{



#if defined(_BSD)

    printf("\nUsage: kc -?bcfghlostu -<1|2>[:]<chars> -<p|w|v>[:]<filename> -z[:]<minutes>");

#elif defined(_SYSV)

    printf("\nUsage: kc -?bcfglostu -<1|2>[:]<chars> -<p|w|v>[:]<filename> -z[:]<minutes>");

#else

    printf("\nUsage: kc -?bcfglostu -<1|2>[:]<chars> -<p|w|v>[:]<filename>");

#endif



    printf("\n       kc -r[:]<filename>\n");

    printf("\nParms: -1 prefix chars       -p /etc/passwd file   -r restore file");

    printf("\n       -2 suffix chars       -w guess word file    -v valid account file\n");

    printf("\nFlags: -? explain usage      -b test backwards     -c test up/low cases");



#if defined(_BSD)

    printf("\n       -f test funny chars   -g test GECOS fields  -h hog resources");

    printf("\n       -l test login names   -o suppress output    -s single char test");

    printf("\n       -t test crypt result  -u user based crack   -z timeout (minutes)");

#elif defined(_SYSV)

    printf("\n       -f test funny chars   -g test GECOS fields  -l test login names");

    printf("\n       -o suppress output    -s single char test   -t test crypt result");

    printf("\n       -u user based crack   -z timeout (minutes)");

#else

    printf("\n       -f test funny chars   -g test GECOS fields  -l test login names");

    printf("\n       -o suppress output    -s single char test   -t test crypt result");

    printf("\n       -u user based crack");

#endif



    printf("\n\nPurpose: Un*x /etc/passwd brute force password cracker.\n");

}



/*===========================================================================*/



/*

**    Function: void main(int argc, char **argv)

** Description: main function

**      Return: none

*/



void main(argc, argv)

    int argc;

    char **argv;

{

    char s[MAX_FILENAME];

    int  i, colon, restoring=0;



    initvars();

    strcpy(progname, argv[0]);

    for (i=1; (i<argc) && (!restoring); i++) {

        strcpy(s, argv[i]);

        colon=(s[2]==':' ? 3 : 2);

        if ((s[0]=='-') || (s[0]=='/')) {

            switch(upchar(s[1])) {

                case '1':

                    strcpy(prefixes, &s[colon]);

                    break;

                case '2':

                    strcpy(suffixes, &s[colon]);

                    break;

                case 'P':

                    strcpy(passwordfile, &s[colon]);

                    break;

                case 'R':

                    initvars();

                    strcpy(restorefile, &s[colon]);

                    if (!restorefile[0])

                        strcpy(restorefile, "restore");

                    restoring=1;

                    break;

                case 'V':

                    strcpy(validfile, &s[colon]);

                    break;

                case 'W':

                    strcpy(wordfile, &s[colon]);

                    break;

                case 'Z':

                    strcpy(s, &s[colon]);

                    colon=atoi(s);

                    if (colon>0)

                        stoptime=colon;

                    break;

                case '?':

                    printtitle();

                    printusage();

                    kc_exit(1);

                    break;

                case 'B':

                case 'C':

                case 'F':

                case 'G':



#ifdef _BSD

                case 'H':

#endif



                case 'L':

                case 'O':

                case 'S':

                case 'U':

                    readoptions(upcase(&s[1]));

                    break;

                case 'T':

                    test_crypt();

                    break;

                default :

                    printtitle();

                    printusage();

                    printf("\n%s: invalid arguments: %s\n", progname, s);

                    kc_exit(1);

                    break;

            }

        }

    }

    if (restoring) {

        if (restore()) {

            printf("\n%s: Invalid restorefile: %s", progname, restorefile);

            kc_exit(1);

        }

    }

    else if (output) {

        printtitle();

        if ((!passwordfile[0]) || (!wordfile[0]) || (!validfile[0]))

            getstat();

        else printfiles();

        printstat();

    }

    if ((passwordfile[0]) && (wordfile[0]) && (validfile[0])) {

        if (initall()==(-1))

            kc_exit(-1);

        crack();

        kc_exit(0);

    }

    else {

        printf("\n%s: invalid command line arguments\n", progname);

        kc_exit(1);

    }

}

