/****************************************************************************\

**         XFDES.C - XTRA FAST DES ENCRYPTION ALOGRITHM FUNCTION            **

******************************************************************************

**             VAX/FDES Routines Modified By Doctor Dissector               **

******************************************************************************

** Copyright (c) 1991, By Doctor Dissector            Last Update: 07/24/91 **

\****************************************************************************/



/*

** XFDES - Version 6.00

** Copyright 1991 By Doctor Dissector

**

** This program is NOT free software BUT may be used without charge or

** payment in any form IF your copy is a "registered" distributed version.

** You may modify it as much as you please, however, you MAY NOT re-

** distribute it, in any shape or for: ie. modified OR unmodified,

** without the expressed written consent (ie. e-mail) of

** Doctor Dissector. (bbs.doctord@doomsday.spies.com)

**

** This program was initially distributed in the hope that it will be

** useful, but WITHOUT ANY WARRANTY; without even the implied warranty of

** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/



/*=[ Copyright ]============================================================*/



char xfdes_h_msg[] = "Source: xfdes.h, Copyright (c)1991 By Doctor Dissector";



/*==========================================================================*/



/*

**  NON_NETORDER tells xfdes that the system you are compiling xfdes on

**  is a non-network byte order compiler/system.  Vaxen, PC's, and other

**  similar machines may have to un-comment this definition in order to

**  get the proper result from kc_xfdes().

*/



/*

#define NON_NETORDER    1

*/



/*=[ Definitions ]==========================================================*/



#define reg     register

#define uns     unsigned

#define unsb    uns char

#define unsl    uns long



/*

** Types for the different ways to represent DES bit patterns

** Bits are *always* right justified within fields

*/



#define obpb1   unsb    /* One bit per byte */

#define sbpb6   unsb    /* Six bits per byte, 6 held */

#define sbpb6R  unsb    /* Six bits per byte, reversed order, 6 held */

#define sbpb24  unsl    /* Six bits per byte, 24 held */

#define ebpb24  unsl    /* Eight bits per byte, 24 held */

#define fbpb4   unsb    /* Four bits per byte, 4 held */

#define fbpb4R  unsb    /* Four bits per byte, reversed order, 4 held */



/*=[ Data Tables ]==========================================================*/



/* Final permutation */

static obpb1 FP[] =

 {

  58,10,70,22,82,34,94,46,57, 9,69,21,81,33,93,45,

  56, 8,68,20,80,32,92,44,55, 7,67,19,79,31,91,43,

  52, 4,64,16,76,28,88,40,51, 3,63,15,75,27,87,39,

  50, 2,62,14,74,26,86,38,49, 1,61,13,73,25,85,37,

   0,                   /* Zero marks the end of the table */

 };



/*

** Permuted-choice 1 from the key bits to yield C and D

** Note that bits 8,16... are left out, they are intended

** for a parity check, not zero based

*/

static unsb PC1_C[] =

 {

  56,48,40,32,24,16, 8,

   0,57,49,41,33,25,17,

   9, 1,58,50,42,34,26,

  18,10, 2,59,51,43,35,

 };



static unsb PC1_D[] =

 {

  62,54,46,38,30,22,14,

   6,61,53,45,37,29,21,

  13, 5,60,52,44,36,28,

  20,12, 4,27,19,11, 3,

 };



/*

** Permuted-choice 2, pick out bits from

** CD array to generate key schedule

*/

static unsb PC2_C[] =

 {

  13,16,10,23, 0, 4,

   2,27,14, 5,20, 9,

  22,18,11, 3,25, 7,

  15, 6,26,19,12, 1,

 };



static unsb PC2_D[] =

 {

  12,23, 2, 8,18,26,

   1,11,22,16, 4,19,

  15,20,10,27, 5,24,

  17,13,21, 7, 0, 3,

};



/* Sequence of shifts used for the key schedule */

static unsb shifts[] =

 {

  1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,

  1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1,

 };



/*

** Pre-calculated salt tables for the first and second characters

** of the salt string

*/

static sbpb24 SALT1[] =

 {

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   1,

     2,   3,   4,   5,   6,   7,   8,   9,

    10,  11,   5,   6,   7,   8,   9,  10,

    11,  12,  13,  14,  15,  16,  17,  18,

    19,  20,  21,  22,  23,  24,  25,  26,

    27,  28,  29,  30,  31,  32,  33,  34,

    35,  36,  37,  32,  33,  34,  35,  36,

    37,  38,  39,  40,  41,  42,  43,  44,

    45,  46,  47,  48,  49,  50,  51,  52,

    53,  54,  55,  56,  57,  58,  59,  60,

    61,  62,  63,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

 };



static sbpb24 SALT2[] =

 {

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,  64,

   128, 192, 256, 320, 384, 448, 512, 576,

   640, 704, 320, 384, 448, 512, 576, 640,

   704, 768, 832, 896, 960,1024,1088,1152,

  1216,1280,1344,1408,1472,1536,1600,1664,

  1728,1792,1856,1920,1984,2048,2112,2176,

  2240,2304,2368,2048,2112,2176,2240,2304,

  2368,2432,2496,2560,2624,2688,2752,2816,

  2880,2944,3008,3072,3136,3200,3264,3328,

  3392,3456,3520,3584,3648,3712,3776,3840,

  3904,3968,4032,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

     0,   0,   0,   0,   0,   0,   0,   0,

 };



#ifndef KC_XFDES

/*

** Character mutation table during final extraction

** of encrypted data, as used by fcrypt

*/

static obpb1 CM[] =

 {

   46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 65, 66, 67, 68,

   69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84,

   85, 86, 87, 88, 89, 90, 97, 98, 99,100,101,102,103,104,105,106,

  107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,

  123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,

  139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,

  155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,

  171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,

  187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,

  203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,

  219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,

  235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,

  251,252,253,254,255,  0,  1,  2,  3,  4,  5,  0,  1,  2,  3,  4,

    5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20,

   21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36,

   37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52,

 };

#else

/* inverse of CM permutation */

static obpb1 ICM[] =

{

  203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,

  219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,

  235,236,237,238,239,240,241,242,243,244,245,246,247,248,  0,  1,

    2,  3,  4,  5,  6,  7,  8,  9, 10, 11,  0,  0,  0,  0,  0,  0,

    0, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26,

   27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37,  0,  0,  0,  0,  0,

    0, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52,

   53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68,

   69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84,

   85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99,100,

  101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,

  117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,

  133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,

  149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,

  165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,

  181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,

};

#endif

